Subject: Re: bug#62672: Unexpected interaction between gobject-introspection and grafts

From: "Collin J. Doering" <[email-masked]>
Date: Wed, 05 Apr 2023 16:21:34 -0400

Hi John,

Thanks for taking the time to chime in, much appreciated!

> https://gitlab.com/podiki/guix-pod/-/blob/main/taffybar.scm

I took a look at your repo and found that our definition of ghc-gi-gdk is almost exactly the same (sans some historical differences (eg, using gtk (v4) vs gtk+)). 

> On the gobject-introspection front, I do remember needing some tinkering
> there for cairo, and ended up using what was suggested here:
> https://issues.guix.gnu.org/49122#4

Interesting! Sadly I rediscovered this and provided a very similar solution in the first message of this bug report (with the help of a similar issue in nix). imho we should adjust the goject-introspection package to include working cairo typelib files.

> Checking now taffybar does not build (some dependent package failing,
> looks like needs an input change) but ghc-gi-gdk does. This should be
> the bulk of the work you need beyond polishing (linting, license checks,
> all that). It is a lot of packages, many are the autogenerated
> haskell-gi packages as I'm sure you are familiar.

I'll take a closer look this evening whether or not there is some other difference that could be causing the reported build failure.

> but hopefully this is helpful

Definitely useful insight, thanks again John!

> Let me know if you need help parsing this early and rough packaging I
> did, though I think it shouldn't take much to get it to build again
> (famous last words, I know).

I don't foresee any issues with understanding whats going on (similarly, famous last works 😉) but if I have any questions I'll let you know in this thread.

On 05 Apr 2023 at 19:55, John Kehayias <[email-masked]> wrote:

> Hi Collin and Josselin,
>
> I haven't fully read this thread but wanted to chime in with work I did
> but never finalized to upstream here. In short, I did get taffybar to
> build and run if I recall. There was a lot of fussing with versions,
> some Haskell packages that were broken/undergoing some breaking changes
> at the time...I don't remember the details, sorry.
>
> https://gitlab.com/podiki/guix-pod/-/blob/main/taffybar.scm
>
> Checking now taffybar does not build (some dependent package failing,
> looks like needs an input change) but ghc-gi-gdk does. This should be
> the bulk of the work you need beyond polishing (linting, license checks,
> all that). It is a lot of packages, many are the autogenerated
> haskell-gi packages as I'm sure you are familiar.
>
> On the gobject-introspection front, I do remember needing some tinkering
> there for cairo, and ended up using what was suggested here:
> https://issues.guix.gnu.org/49122#4
>
> I haven't used Taffybar much since I went back to my lisp land (StumpWM)
> but hopefully this is helpful. Some Haskell experts can chime in with
> other details or polishing once it builds.
>
> Let me know if you need help parsing this early and rough packaging I
> did, though I think it shouldn't take much to get it to build again
> (famous last words, I know).
>
> John

-- 
Collin J. Doering

http://rekahsoft.ca
http://blog.rekahsoft.ca
http://git.rekahsoft.ca